/*
    Copyright 2007 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt
*/

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include "bf2_sniff.h"



#ifdef CLIENT
    #define CMD1 "bf2142.exe"
    #define CMD2 "bf2.exe"
#elif SERVER
    #define CMD1 "BF2142_w32ded.exe +ignoreAsserts 1 +dedicated 1 +config @HOME@/ServerConfigs/_serverSettings.con +mapList @HOME@/ServerConfigs/_maplist.con"
    #define CMD2 "BF2_w32ded.exe +ignoreAsserts 1 +dedicated 1 +config @HOME@/ServerConfigs/_serverSettings.con +mapList @HOME@/ServerConfigs/_maplist.con"
#else
    #error "you must specify -DCLIENT or -DSERVER"
#endif
#define DLL     "bf2_sniff.dll"



void winerr(void) {
    char    *error = NULL;

    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
        NULL,
        GetLastError(),
        0,
        (char *)&error,
        0,
        NULL);
    if(error) {
        printf("\nError: %s\n", error);
        LocalFree(error);
    }
    printf("\nPress RETURN to quit\n");
    fgetc(stdin);
    exit(1);
}



int main(int argc, char *argv[]) {
	STARTUPINFO         si;
	PROCESS_INFORMATION pi;
    void    *dllmem;
    char    *cmd = NULL,
            *dll;

    fputs(TITLE, stdout);

    printf("\n"
        "Usage: %s [command] [dll]\n"
        "\n", argv[0]);

    dll = DLL;
    if(argc > 1) cmd = argv[1];
    if(argc > 2) dll = argv[2];

    GetStartupInfo(&si);
    if(!cmd) {
        printf("execute:\n%s\n", CMD1);
        if(!CreateProcess(NULL, CMD1, NULL, NULL, FALSE, CREATE_SUSPENDED, NULL, NULL, &si, &pi)) {
            printf("execute:\n%s\n", CMD2);
            if(!CreateProcess(NULL, CMD2, NULL, NULL, FALSE, CREATE_SUSPENDED, NULL, NULL, &si, &pi)) winerr();
        }
    } else {
        printf("execute:\n%s\n", cmd);
        if(!CreateProcess(NULL, cmd, NULL, NULL, FALSE, CREATE_SUSPENDED, NULL, NULL, &si, &pi)) winerr();
    }

    dllmem = VirtualAllocEx(pi.hProcess, NULL, strlen(dll) + 1, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
    if(!dllmem) winerr();

    if(!WriteProcessMemory(pi.hProcess, dllmem, dll, strlen(dll) + 1, NULL)) winerr();

    if(!CreateRemoteThread(pi.hProcess, NULL, 0, (LPTHREAD_START_ROUTINE)GetProcAddress(GetModuleHandle("Kernel32.dll"), "LoadLibraryA"), dllmem, 0, NULL)) winerr();

    ResumeThread(pi.hThread);

    printf("\nDLL %s injected\n", dll);
    printf("\n"
        "Press RETURN to quit\n"
        "this window is no longer needed so you can quit now\n");
    fgetc(stdin);
    return(0);
}


